/*
 * $Id$
 * 
 */
package com.asprise.util.jsane;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.UIManager;

/**
 * Sample JImageDialog application. 
 * 
 */
public class JSaneDialogSampleApp extends JPanel {
	
	Image image; 
	
	public JSaneDialogSampleApp() {
		super();
	}

	/**
	 * Display image if any. 
	 */
	public void paintComponent(Graphics g) {
		super.paintComponent(g); // Paint background. 
		if(image != null)
			g.drawImage(image, 0, 0, null);
	}

	public Dimension getMinimumSize() {
		if(image == null)
			return new Dimension(600, 400);
		else
			return new Dimension(image.getWidth(null), image.getHeight(null));
	}

	public Dimension getPreferredSize() {
		return getMinimumSize();
	}
	
	public void setImage(Image image) {
		this.image = image;

		setPreferredSize(getPreferredSize());
		revalidate();
		repaint();
	}

	
	public static void main(String[] args) throws IOException {
	 
		final JFrame frame = new JFrame("JSaneDialog Sample Application");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		final JSaneDialogSampleApp panel = new JSaneDialogSampleApp();
		
		JButton button = new JButton("Click here to set image ...");
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				// ********** JSaneDialog ******************************* 
				JSaneDialog dialog = new JSaneDialog(JSaneDialog.CP_START_SANED_LOCALHOST, frame, "JSaneDialog", true, null);
				panel.setImage(dialog.openDialog());
			}
		});
		
		frame.getContentPane().setLayout(new BorderLayout());
		frame.getContentPane().add(button, BorderLayout.NORTH);
		frame.getContentPane().add(new JScrollPane(panel), BorderLayout.CENTER);
		
		frame.pack();
		frame.setVisible(true);
	}
	
}
